#version 330 core

uniform sampler2D texture2;
uniform vec3 color0;
uniform float alpha0;

in vec2 texCoord0;
flat in vec4 tileCoord;

out vec4 fragColor;

void main() 
{
    vec2 finalCoord = mix(tileCoord.xy, tileCoord.zw, texCoord0);
    float alpha = texture(texture2, finalCoord).r;
    fragColor = vec4(color0, min(alpha, alpha0));
}
