#version 330 core

uniform sampler2D texture2; // barbs atlas
uniform sampler1D texture4; // colormap
uniform float alpha0;
uniform vec2 range;

in vec2 texCoord0;
flat in float windSpeedKnot;
flat in float angle;
flat in vec4 tileCoord;

out vec4 fragColor;

// Clamp the value between [min, max] and normalize to [0, 1]
float saturateToRange(in float value, in vec2 range)
{
    float result = clamp(value, range.x, range.y);
    return (result - range.x) / (range.y - range.x);
}

void main() 
{
    vec2 finalCoord = mix(tileCoord.xy, tileCoord.zw, texCoord0);
    float alpha = texture(texture2, finalCoord).r;
    float value = saturateToRange(windSpeedKnot, range);
    vec3 color = texture(texture4, value).rgb;
    fragColor = vec4(color, min(alpha, alpha0));
}
