#version 330 core

const float PI = 3.141592653589793;

uniform vec4 color;

in float lineWidth;
in vec2 texCoord0;
flat in float segmentLength;

out vec4 color1;

void main()
{
    float dx = texCoord0.x;
    float dy = abs(texCoord0.y);
    float d = dy;
    
    float antialias = 1.0;
    //float t = (thickness / halfViewport.x / 2.0);// - (1.5/400.0)*antialias;
    float t = lineWidth;// - (1.5/400.0)*antialias;

    if (texCoord0.x < 0.0)
    {
        d = length(texCoord0);
    }
    else if (texCoord0.x > segmentLength)
    {
        d = length(vec2(texCoord0.x - segmentLength, texCoord0.y));
    }

    d = d - t;
    float a = 1.0;

    if( d > 0.0 )
    {
        a = exp(-d*d);
        if( a < 0.01 )
            discard;
    }

    color1 = vec4(color.rgb, color.a * a);
}
