#version 330 core

uniform sampler2D texture0; // data
uniform sampler2D texture1; // mask
uniform vec4 scaleFactor;
uniform vec4 offset;
uniform float glFactor;

in vec2 texCoord0;
out vec4 out_Color;

void main()
{
    float mask = texture(texture1, texCoord0).r;

    if (mask > 0.0)
    {
        vec2 raw_value = ((texture(texture0, texCoord0).rg * glFactor) * scaleFactor.rg) + offset.rg;
        out_Color = vec4(raw_value, 0.0, 0.0);
    }
    else
    {
        discard;
    }
}
