#version 330 core

uniform sampler2D texture0; // data
uniform sampler2D texture1; // mask

uniform vec3 scaleFactor;
uniform vec3 offset;
uniform float multiplicator;

#define readTexture3(texUnit, coord) ((texture(texUnit, coord).rgb * multiplicator) * scaleFactor) + offset

in vec2 texCoord0;
out vec4 out_Color;

void main()
{
    float mask = texture(texture1, texCoord0).r;

    if (mask > 0.0)
    {
        vec3 value = readTexture3(texture0, texCoord0);
        out_Color = vec4(value.bgr, 1.0);
    }
    else
    {
        discard;
    }
}