#version 330 core

layout(location = 0) in vec2 position;
// Position of the vertex in the current streamline [0, streamlineLength-1]
layout(location = 1) in float localID;

uniform mat4 mvp;
uniform float streamlineLength;
uniform vec3 fillColor;

out vec4 color0;

vec3 ToVector3D(vec2 geodetic)
{
    float cosLatitude = cos(geodetic.y);

    return normalize(vec3(
        cosLatitude * cos(geodetic.x),
        cosLatitude * sin(geodetic.x),
        sin(geodetic.y)));
}

void main()
{
    color0.a = localID / streamlineLength;
    color0.rgb = fillColor;

    gl_Position = mvp * vec4(ToVector3D(position), 1.0);
}
