precision mediump float;

uniform sampler2D texture0; // data 0
uniform sampler2D texture1; // data 1
uniform sampler2D texture2; // worldmap
uniform sampler2D texture3; // palette
uniform sampler2D texture4; // data target

varying vec2 texCoord0;

void main()
{
    vec4 t0 = texture2D(texture0, texCoord0);
    vec4 t1 = texture2D(texture1, texCoord0);
    vec4 target = texture2D(texture4, texCoord0);

    if (t0.b < 1.0 && t1.b < 1.0)
    {  
        //float result = (t0.r + t1.r);
        float result = sqrt(pow(t0.r + t1.r, 2.0) + pow(t0.g + t1.g, 2.0));
        //float result = sqrt(pow(t0.r, 2) + pow(t0.g, 2));
        float target_value = sqrt(pow(target.r, 2.0) + pow(target.g, 2.0));
        //float result = max(t0.r , t1.r);
        //float error = abs((result - target.r));
        //float error = abs((result - target.r) / target.r);
        float error = abs((result - target_value) / target_value);

        gl_FragColor = texture2D(texture3, vec2(error, 0.5));
    }
    else
    {
        gl_FragColor = texture2D(texture2, texCoord0);
    }
}