precision mediump float;

uniform sampler2D texture0; // data
uniform sampler2D texture1; // target

varying vec2 texCoord0;

void main()
{
    vec4 t0 = texture2D(texture0, texCoord0);
    vec4 t1 = texture2D(texture1, texCoord0);

    if (t0.b > 0.0)
    {  
        float error = abs((t0.r - t1.r) / t1.r);
        gl_FragColor = vec4(error, 0.0, 1.0, 1.0);
    }
    else
    {
        discard;
    }
}