precision mediump float;

uniform sampler2D texture0; // data 0
uniform sampler2D texture1; // data 1

varying vec2 texCoord0;

void main()
{
    vec4 t0 = texture2D(texture0, texCoord0);
    vec4 t1 = texture2D(texture1, texCoord0);

    // data is in rg channels, mask is in b channel.
    if (t0.b > 0.0 && t1.b > 0.0)
    {  
        // Compute module of sums
        float result = sqrt(pow(t0.r + t1.r, 2.0) + pow(t0.g + t1.g, 2.0));
        
        // Save result in r channel and mask in b channel
        gl_FragColor = vec4(result, 0.0, 1.0, 1.0);
    }
    else
    {
        discard;
    }
}