precision mediump float;

uniform sampler2D texture0; // data 0
uniform sampler2D texture1; // data 1
uniform sampler2D texture2; // palette

uniform vec2 range;

varying vec2 texCoord0;

void main()
{
    vec4 t0 = texture2D(texture0, texCoord0);
    vec4 t1 = texture2D(texture1, texCoord0);

    //float tmp =  length(t0.xy) / 10.0;
//    gl_FragColor = texture2D(texture2, vec2(tmp, 0.5));
    //gl_FragColor = vec4(tmp, 0.0, 0.0, 1.0);
    //return;

    // data is in rg channels, mask is in b channel.
    if (t0.b > 0.0 && t1.b > 0.0)
    {  
        // Compute module of sums
        float result = sqrt(pow(t0.r + t1.r, 2.0) + pow(t0.g + t1.g, 2.0));

        //result = clamp(result, range.x, range.y);
        
        //color = vec4(result, 0.0, 0.0, 1.0);
        //return;

	result = (result - range.x) / (range.y - range.x);
	
        // Save result in r channel and mask in b channel
        gl_FragColor = texture2D(texture2, vec2(result, 0.5));
    }
    else
    {
        //gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
        discard;
    }
}