#version 100

precision highp float;

uniform sampler2D texture2;
uniform vec3 color0;
uniform float alpha0;

varying vec2 texCoord0;
varying vec4 tileCoord;
varying float angle;

void main() 
{
    vec2 finalCoord = mix(tileCoord.xy, tileCoord.zw, vec2(texCoord0.x, texCoord0.y));

    vec2 tex = texCoord0 - 0.5;
    float s = sin ( angle );
    float c = cos ( angle );
    mat2 rotationMatrix = mat2( c, -s, s, c);
    rotationMatrix *= 0.5;
    rotationMatrix += 0.5;
    rotationMatrix = rotationMatrix * 2.0 - 1.0;
    tex = rotationMatrix  * tex;
    tex += 0.5; 

    tex = clamp(tex, 0.0, 1.0);
    finalCoord = mix(tileCoord.xy, tileCoord.zw, tex);

    float alpha = texture2D(texture2, finalCoord).r;

    gl_FragColor = vec4(color0, min(alpha, alpha0));
}
