precision highp float;

const float PI = 3.141592653589793;

uniform sampler2D texture0;

varying float lineWidth;
varying vec2 texCoord0;
varying vec3 color0;
varying float segmentLength;
varying float data0;

void main()
{
    float dx = texCoord0.x;
    float dy = abs(texCoord0.y);
    float d = dy;
    vec4 color = vec4(color0, 1.0);
    
    float antialias = 1.0;
    float t = lineWidth;

    if (texCoord0.x < 0.0)
    {
        d = length(texCoord0);
    }
    else if (texCoord0.x > segmentLength)
    {
        d = length(vec2(texCoord0.x - segmentLength, texCoord0.y));
    }

    d = d - t;

    if( d <= 0.0 )
    {
        //gl_FragColor = vec4(color0, 1.0);
        gl_FragColor = vec4(texture2D(texture0, vec2(data0, 0.5)).rgb, 1.0);
    }
    else
    {
        //d /= antialias;
        float a = exp(-d*d);// * color.a;
        if( a < 0.001 )
            discard;
        else
            //gl_FragColor = vec4(color0, a);
            gl_FragColor = vec4(texture2D(texture0, vec2(data0, 0.5)).rgb, a);
    }
}
