#version 100

precision highp float;

uniform sampler2D texture0; // data
uniform sampler2D texture1; // mask
uniform vec2 textureRatio;
uniform vec3 uncompress; // multiplicator, offset, scaleFactor

#define MULTIPLICATOR   uncompress.r
#define OFFSET          uncompress.g
#define SCALEFACTOR     uncompress.b

#define readTexture2(texUnit, coord) ((texture2D(texUnit, coord).ra * MULTIPLICATOR) * SCALEFACTOR) + OFFSET

varying vec2 texCoord0;

void main()
{
    float mask = texture2D(texture1, texCoord0 * textureRatio).r;

    if (mask > 0.0)
    {
        vec2 raw_value = readTexture2(texture0, texCoord0 * textureRatio);
        gl_FragColor = vec4(raw_value, 1.0, 0.0);
    }
    else
    {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}