precision mediump float;

#define PI 3.14159265359
#define oneOverTwoPi 0.15915494309
#define oneOverPi 0.31830988618

uniform sampler2D texture0;

varying vec3 position0;

vec2 ComputeTextureCoordinates(vec3 normal)
{
    return vec2(-(atan(normal.x, normal.y) / 3.1415926 + 0.5) * 0.5, -(asin(normal.z) / 3.1415926 + 0.5));
}

void main()
{
    vec3 normal = normalize(position0);
    gl_FragColor = texture2D(texture0, ComputeTextureCoordinates(normal));
}