#version 100

attribute vec2 position;

uniform vec4 top;
uniform vec4 bottom;
uniform mat4 mvp;

#define PI      3.14159265359
#define TWO_PI  6.28318530718

vec3 ToVector3D(vec2 geodetic)
{
    float cosLatitude = cos(geodetic.y);

    return normalize(vec3(
        cosLatitude * cos(geodetic.x),
        cosLatitude * sin(geodetic.x),
        sin(geodetic.y)));
}

void main()
{
    vec2 topMix = mix(top.xy, top.zw, position.x);
    vec2 bottomMix = mix(bottom.xy, bottom.zw, position.x);
    vec2 lonlat = mix(topMix, bottomMix, position.y);

    gl_Position = mvp * vec4(ToVector3D(lonlat), 1.0);
}
