#version 100

precision highp float;

attribute vec2 position;

uniform sampler2D texture0; // 
uniform sampler2D texture1; // 
uniform sampler2D texture2; // 
//uniform sampler2D texture3; // 
uniform vec4 bbox; // lonMin/latMin/lonMax/latMax
uniform vec2 ratio; // lonMin/latMin/lonMax/latMax
uniform float speed;

varying vec2 position0;

const float PI = 3.141592653589793;
/*
float decodeFloatRGBA(vec4 rgba) 
{
    return dot(rgba, vec4(1.0, 1.0/255.0, 1.0/65025.0, 1.0/16581375.0));
}*/

void main()
{
    // Get particle informations
    //vec2 particleData;
    //particleData.x = decodeFloatRGBA(texture2D(texture0, position)) * (2.0 * PI) - PI;
    //particleData.y = decodeFloatRGBA(texture2D(texture1, position)) * PI - (PI / 2.0);

    vec4 particleData = texture2D(texture0, position);

    vec2 texCoord;
    texCoord.x = (particleData.x - bbox.x) / (bbox.z - bbox.x);
    texCoord.y = (particleData.y - bbox.y) / (bbox.w - bbox.y);

    //vec2 dir = texture2D(texture2, texCoord * ratio).ra;
    //float mask = texture2D(texture3, texCoord * ratio).r;

    vec2 dir = texture2D(texture1, texCoord * ratio).ra;
    float mask = texture2D(texture2, texCoord * ratio).r;

    if (mask > 0.0)
    {
        vec2 newPosition = particleData.xy + dir.xy * speed;
        newPosition = newPosition + vec2(PI, PI/2.0);
        newPosition = mod(newPosition, vec2(2.0 * PI, PI));
        newPosition = newPosition - vec2(PI, PI/2.0);
        position0 = newPosition;
    }
    else
    {
        position0 = particleData.xy;
    }

    vec2 clipPosition = position * 2.0 - 1.0;
    gl_Position = vec4(clipPosition, 0.0, 1.0);
}
