#version 100

precision highp float;

attribute highp vec2 position;

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform vec4 bbox; // lonMin/latMin/lonMax/latMax
uniform vec2 ratio; // lonMin/latMin/lonMax/latMax
uniform highp float speed;

varying highp vec2 position0;

const float PI = 3.141592653589793;

void main()
{
    // Get particle informations
    highp vec4 particleData = texture2D(texture0, position);
    
    vec2 texCoord;
    texCoord.x = (particleData.x - bbox.x) / (bbox.z - bbox.x);
    texCoord.y = (particleData.y - bbox.y) / (bbox.w - bbox.y);

    highp vec2 dir = texture2D(texture1, texCoord * ratio).xy;
    float mask = texture2D(texture2, texCoord * ratio).x;

    if (mask > 0.0)
    {
        //vec2 newPosition = particleData.xy + particleData.zw * time;
        highp vec2 newPosition = (particleData.xy + dir.xy * speed);// / vec2(2.0 * PI, PI) * vec2(65536.0, 65536.0);
        //highp vec2 newPosition = (particleData.xy + vec2(0.1, 0.0));
        //vec2 newPosition = particleData.xy;
        position0 = newPosition;
    }
    else
    {
        position0 = particleData.xy;
    }

    /*vec2 ll = particleData.xy - vec2(0.0001, 0.0);

    if (ll.x > PI)
    {
        ll.x -= 2.0 * PI;
    }

    position0 = ll;*/

    vec2 clipPosition = position * 2.0 - 1.0;
    gl_Position = vec4(clipPosition, 0.0, 1.0);
}
