#version 100

attribute vec2 position;

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform mat4 mvp;
uniform vec4 bbox;
uniform vec2 ratio;

const float PI = 3.141592653589793;

vec3 ToVector3D(vec2 geodetic)
{
    vec3 result;
    result = vec3(-0.25 + ((geodetic.x + PI) / (2.0 * PI)) * 0.5,
                  -0.125 + ((geodetic.y + (PI / 2.0)) / PI) * 0.25,
                  0.0);
    return result;
}

//float decodeFloatRGBA(vec4 rgba) 
//{
//    return dot(rgba, vec4(1.0, 1.0/255.0, 1.0/65025.0, 1.0/16581375.0));
//}

void main()
{
    // Get particle informations
    //vec2 particleData;
    //particleData.x = decodeFloatRGBA(texture2D(texture0, position)) * (2.0 * PI) - PI;
    //particleData.y = decodeFloatRGBA(texture2D(texture1, position)) * PI - (PI / 2.0);

    vec4 particleData = texture2D(texture0, position);

    vec2 texCoord;
    texCoord.x = (particleData.x - bbox.x) / (bbox.z - bbox.x);
    texCoord.y = (particleData.y - bbox.y) / (bbox.w - bbox.y);

    //vec2 dir = texture2D(texture1, texCoord).xy;
    float mask = texture2D(texture2, texCoord * ratio).x;

    //if (mask > 0.0)
    {
        gl_Position = mvp * vec4(ToVector3D(particleData.xy), 1.0);
    }
    //else
    {
        //gl_Position = vec4(-2.0, 0.0, 0.0, 1.0);
    }
}
